/*
**	AberMUD Database Definitions
*/
#include "kernel.h"
#include "condact.h"
#include "objects.h"
#include "verbs.h"

#ifdef	RCSID
static char RCS[] =
	"$Header: database.c,v 1.1 89/03/13 09:35:57 rsalz Exp $";
#endif	/* RCSID */

/*
** Events.
**
** The order of objects with same names should NOT be changed.
**
*/

LINE event[] = {

/* Drink from chalice */
VERB_EAT, OBJ_CHALICE, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   260, DONE, NULL, NULL,

/* Put chalice on altar */
VERB_PUT, OBJ_CHALICE, OBJ_ALTAR,
   PAR,OBJ_CHALICE, PAR,OBJ_ALTAR, PAR,1, PAR,0, PAR,0, PAR,0,
   DESTROY, SETSTATE, OK, NULL,

/* Pray at altar + chalice */
VERB_PRAY, ANY, ANY,
   HERE,OBJ_ALTAR, STATE,OBJ_ALTAR, NULL,1, PAR,-2500, PAR,OBJ_ALTAR, PAR,0,
   261, GOTO, SETSTATE, DONE,

/* pray loc < -2500 + some other conditions */
VERB_PRAY, ANY, ANY,
   INLT,-2500, NOT|INLT,-2600, PAR,-633, CHANCE,50, NOT|IFFIGHTING,0, PAR,0,
   264, GOTO, DONE, NULL,

/* Get or put stuff on altar */
VERB_GET, ANY, OBJ_ALTAR,
   STATE,OBJ_ALTAR, NULL,1, PAR,0, PAR,0, PAR,0, PAR,0,
   262, DONE, NULL, NULL,

/* Same for the remove */
VERB_REMOVE, ANY, OBJ_ALTAR,
   STATE,OBJ_ALTAR, NULL,1, PAR,0, PAR,0, PAR,0, PAR,0,
   262, DONE, NULL, NULL,

/* debug; patch PFLAG check */
VERB_DEBUG, ANY, ANY,
   NOT|PFLAG,FL_MYNUM, NULL,11, PAR,0, PAR,0, PAR,0, PAR,0,
   255, DONE, NULL, NULL,

/* pnum */
VERB_PNUM, PL, ANY,
   PAR,FL_PL1, OP,0, PAR,0, PAR,0, PAR,0, PAR,0,
   2050, PNUMBER, 265, DONE,

/* drop */
VERB_DROP, OB, OBJ_PIT_1,
   PAR,FL_OB1, PAR,-2207, PAR,0, PAR,0, PAR,0, PAR,0,
   PUT, OK, NULL, NULL,

/* throw */
VERB_THROW, OB, OBJ_PIT_1,
   PAR,FL_OB1, PAR,-2207, PAR,0, PAR,0, PAR,0, PAR,0,
   PUT, OK, NULL, NULL,

/* go raft */
VERB_GO, OBJ_RAFT, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   233, DONE, NULL, NULL,

/* go boat */
VERB_GO, OBJ_BOAT, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   233, DONE, NULL, NULL,

/* give pipes to Shazareth */
VERB_GIVE, P(37), OBJ_PIPES,
   PHERE,37, PAR,48, PAR,0, PAR,0, PAR,0, PAR,0,
   GIVE, 247, BROAD, OK,

/* give pipes to Shazareth */
VERB_GIVE, OBJ_PIPES, P(37),
   PHERE,37, PAR,48, PAR,0, PAR,0, PAR,0, PAR,0,
   GIVE, 247, BROAD, OK,

/* play the pipes */
VERB_PLAY, OBJ_PIPES, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   249, DONE, NULL, NULL,

/* cut ladder */
VERB_CUT, OBJ_LADDER, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   240, DONE, NULL, NULL,

/* cut ladder 1 */
VERB_CUT, OBJ_LADDER_1, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   240,DONE,NULL,NULL,

/* cut rope 1 */
VERB_CUT, OBJ_ROPE_1, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   240, DONE, NULL, NULL,

/* cut rope 2 */
VERB_CUT, OBJ_ROPE_2, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   240, DONE, NULL, NULL,

/* cut rope 3 */
VERB_CUT, OBJ_ROPE_3, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   240, DONE, NULL, NULL,

/* cut rope 4 */
VERB_CUT, OBJ_ROPE_4, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   240, DONE, NULL, NULL,

/* cut rope 5 */
VERB_CUT, OBJ_ROPE_5, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   240, DONE, NULL, NULL,

/* tie ladder down tree (rope 5) */
VERB_TIE, OBJ_ROPE_5, ANY,
   IN,-1105, PAR,228, PAR,235, PAR,229, PAR,0, PAR,0,
   CREATE, DESTROY, CREATE, OK,

/* untie rope 5 */
VERB_UNTIE, OBJ_ROPE_5, ANY,
   STATE,234, NULL,0, PAR,232, PAR,0, PAR,0, PAR,0,
   241, INC, NULL, NULL,           

/* turn ladder into pure rope (rope 5) */
VERB_UNTIE, OBJ_ROPE_5, ANY,
   STATE,234, NULL,0, PAR,234, PAR,228, PAR,230, PAR,0,
   INC, INC, INC, DONE,

/* untie (rope 5) */
VERB_UNTIE, OBJ_ROPE_5, ANY,
   STATE,204, NULL,2, PAR,232, PAR,0, PAR,0, PAR,0,
   NULL, DEC, NULL, NULL,           

/* untie rope knot (rope 5) */
VERB_UNTIE, OBJ_ROPE_5, ANY,
   STATE,234, NULL,2, PAR,234, PAR,228, PAR,230, PAR,0,
   DEC, DEC, DEC, OK,

/* knot (rope 5) */
VERB_KNOT, OBJ_ROPE_5, ANY,
   STATE,234, NULL,2, PAR,0, PAR,0, PAR,0, PAR,0,
   243, DONE, NULL, NULL,

/* knot (rope 5) */
VERB_KNOT, OBJ_ROPE_5, ANY,
   STATE,234, NULL,0, PAR,0, PAR,0, PAR,0, PAR,0,
   242, DONE, NULL, NULL,

/* knot (rope 5) */
VERB_KNOT, OBJ_ROPE_5, ANY,
   STATE,234, NULL,1, PAR,232, PAR,0, PAR,0, PAR,0,
   INC, NULL, NULL, NULL,

/* knot (rope 5) */
VERB_KNOT, OBJ_ROPE_5, ANY,
   STATE,234, NULL,1, PAR,230, PAR,228, PAR,234, PAR,0,
   INC,INC,INC,OK,

/* up */
VERB_UP, ANY, ANY,
   HERE,228, PAR,229, NOT|IFFIGHTING,0, PAR,0, PAR,0, PAR,0,
   GOBY, DONE, NULL, NULL,

/* down */
VERB_DOWN, ANY, ANY,
   HERE,229, PAR,228, NOT|IFFIGHTING,0, PAR,0, PAR,0, PAR,0,
   GOBY, DONE, NULL, NULL,

/* knot (rope 5) */
VERB_KNOT, OBJ_ROPE_5, ANY,
   IN,-620, PAR,234, PAR,228, PAR,229, PAR,0, PAR,0,
   DESTROY, CREATE, CREATE, 244,

/* knot (rope 5) */
VERB_KNOT, OBJ_ROPE_5, ANY,
   IN,-620, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   DONE, NULL, NULL, NULL,

/* knot (rope 5) */
VERB_KNOT, OBJ_ROPE_5, ANY,
   IN,-1105, PAR,234, PAR,228, PAR,229, PAR,0, PAR,0,
   DESTROY, CREATE, CREATE, 244,

/* knot (rope 5) */
VERB_KNOT, OBJ_ROPE_5, ANY,
   IN,-1105, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   DONE, NULL, NULL, NULL,

/* untie ladder */
VERB_UNTIE, OBJ_LADDER, ANY,
   PAR,234, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   CREATE, NULL, NULL, NULL,            

/* untie ladder */
VERB_UNTIE, OBJ_LADDER, ANY,
   PAR,228, PAR,229, PAR,234, PAR,FL_CURCH, PAR,0, PAR,0,            
   DESTROY, DESTROY, PUT, OK,

/* untie ladder 1 */
VERB_UNTIE, OBJ_LADDER_1, ANY,
   PAR,234, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   CREATE, NULL, NULL, NULL,            

/* untie ladder 1 */
VERB_UNTIE, OBJ_LADDER_1, ANY,
   PAR,228, PAR,229, PAR,234, PAR,FL_CURCH, PAR,0, PAR,0,            
   DESTROY, DESTROY, PUT, OK,

/* throw (rope 5) */
VERB_THROW, OBJ_ROPE_5, ANY,
   IN,-620, PAR,234, PAR,228, PAR,229, PAR,0, PAR,0,
   DESTROY, CREATE, CREATE, 244,

/* throw (rope 5) */
VERB_THROW, OBJ_ROPE_5, ANY,
   IN,-620, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   DONE, NULL, NULL, NULL,

/* throw (rope 5) */
VERB_THROW, OBJ_ROPE_5, ANY,
   IN,-1105, PAR,234, PAR,228, PAR,229, PAR,0, PAR,0,
   DESTROY, CREATE, CREATE, 244,

/* throw (rope 5) */
VERB_THROW, OBJ_ROPE_5, ANY,
   IN,-1105, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   DONE, NULL, NULL, NULL,                      

/* knot (rope 5) */
VERB_KNOT, OBJ_ROPE_5, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   245, DONE, NULL, NULL,

/* west */
VERB_WEST, ANY, ANY,
   IN,-2200, HERE,233, PAR,-696, NOT|IFFIGHTING,0, PAR,0, PAR,0,
   GOTO, DONE, NULL, NULL,

/* east */
VERB_EAST, ANY, ANY,
   IN,-696, HERE,232, PAR,-2200, NOT|IFFIGHTING,0, PAR,0, PAR,0,
   GOTO, DONE, NULL, NULL,

/* throw (rope 5) */
VERB_THROW, OBJ_ROPE_5, ANY,
   IN,-2200, CHANCE,50, PAR,0, PAR,0, PAR,0, PAR,0,
   252, DONE, NULL, NULL,

/* throw (rope 5) */
VERB_THROW, OBJ_ROPE_5, ANY,
   IN,-2200, PAR,0, PAR,0, PAR,0, PAR,0,PAR,0,
   251, NULL, NULL, NULL,

/* throw (rope 5) */
VERB_THROW, OBJ_ROPE_5, ANY,
   IN,-2200, PAR,232, PAR,233, PAR,234, PAR,0, PAR,0,
   CREATE, CREATE, DESTROY, DONE,

/* throw (rope 5) */
VERB_THROW, OBJ_ROPE_5, ANY,
   IN,-696, CHANCE,50, PAR,0, PAR,0, PAR,0, PAR,0,
   252, DONE, NULL, NULL,

/* throw (rope 5) */
VERB_THROW, OBJ_ROPE_5, ANY,
   IN,-696, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   251, NULL, NULL, NULL,

/* throw (rope 5) */
VERB_THROW, OBJ_ROPE_5, ANY,
   IN,-2207, PAR,230, PAR,231, PAR,234, PAR,0, PAR,0,
   CREATE, CREATE, DESTROY, 257,

/* throw (rope 5) */
VERB_THROW, OBJ_ROPE_5, ANY,
   IN,-2207, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   DONE, NULL, NULL, NULL,

/* throw (rope 5) */
VERB_THROW, OBJ_ROPE_5, ANY,
   IN,-702, PAR,231, PAR,230, PAR,234, PAR,0, PAR,0,
   CREATE, CREATE, DESTROY, OK,

/* throw (rope 5) */
VERB_THROW, OBJ_ROPE_5, ANY,
   IN,-696, PAR,232, PAR,233, PAR,234, PAR,0, PAR,0,
   CREATE, CREATE, DESTROY, OK,
            
/* tie (rope 5) */
VERB_TIE, OBJ_ROPE_5, ANY,
   IN,-702, PAR,230, PAR,231, PAR,234, PAR,0, PAR,0,
   CREATE, CREATE, DESTROY, 258,

/* tie (rope 5) */
VERB_TIE, OBJ_ROPE_5, ANY,
   IN,-702, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   DONE, NULL, NULL, NULL,

/* untie (rope 1) */
VERB_UNTIE, OBJ_ROPE_1, ANY,
   PAR,230, PAR,231, PAR,234, PAR,234, PAR,FL_MYNUM, PAR,0,
   DESTROY, DESTROY, CREATE, PUTCARR,

/* untie (rope 1) */
VERB_UNTIE, OBJ_ROPE_1, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   OK, NULL, NULL, NULL,

/* untie (rope 2) */
VERB_UNTIE, OBJ_ROPE_2, ANY,
   PAR,230, PAR,231, PAR,234, PAR,234, PAR,FL_MYNUM, PAR,0,
   DESTROY, DESTROY, CREATE, PUTCARR,

/* untie (rope 2) */
VERB_UNTIE, OBJ_ROPE_2, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   OK, NULL, NULL, NULL,

/* tie (rope 3) */
VERB_UNTIE, OBJ_ROPE_3, ANY,
   PAR,232, PAR,233, PAR,234, PAR,234, PAR,FL_MYNUM, PAR,0,
   DESTROY, DESTROY, CREATE, PUTCARR,

/* tie (rope 3) */
VERB_UNTIE, OBJ_ROPE_3, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   OK, NULL, NULL, NULL,

/* untie (rope 4) */
VERB_UNTIE, OBJ_ROPE_4, ANY,
   PAR,232, PAR,233, PAR,234, PAR,234, PAR,FL_MYNUM, PAR,0,
   DESTROY, DESTROY, CREATE, PUTCARR,

/* untie (rope 4) */
VERB_UNTIE, OBJ_ROPE_4, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   OK, NULL, NULL, NULL, 

/* turn (rope 3) */
VERB_TURN, OBJ_ROPE_3, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   253, DONE, NULL, NULL,

/* turn (rope 4) */
VERB_TURN, OBJ_ROPE_4, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   253, DONE, NULL, NULL,

/* down */
VERB_DOWN, ANY, ANY,
   IN,-702, HERE,230, PAR,-2207, NOT|IFFIGHTING,0, PAR,0, PAR,0,
   GOTO, DONE, NULL, NULL,

/* up */
VERB_UP, ANY, ANY,
   IN,-2207, HERE,231, PAR,-702, NOT|IFFIGHTING,0, PAR,0, PAR,0,
   GOTO, DONE, NULL, NULL,

/* get ladder */
VERB_GET, OBJ_LADDER, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   266, DONE, NULL, NULL,

/* get ladder 1 */
VERB_GET, OBJ_LADDER_1, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   266, DONE, NULL, NULL,

/* get rope 1 */
VERB_GET, OBJ_ROPE_1, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   266, DONE, NULL, NULL,

/* get rope 2 */
VERB_GET, OBJ_ROPE_2, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   266, DONE, NULL, NULL,

/* get rope 3 */
VERB_GET, OBJ_ROPE_3, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   266, DONE, NULL, NULL,

/* get rope 4 */
VERB_GET, OBJ_ROPE_4, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   266, DONE, NULL, NULL,

/* setin */
VERB_SETIN, ANY, ANY,
   NOT|WIZ,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   204, DONE, NULL, NULL,

/* setout */
VERB_SETOUT, ANY, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   204, DONE, NULL, NULL,

/* setmin */
VERB_SETMIN, ANY, ANY,
   NOT|WIZ,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   204, DONE, NULL, NULL,

/* setmout */
VERB_SETMOUT, ANY, ANY,
   NOT|WIZ,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   204, DONE, NULL, NULL,

/* setin */
VERB_SETIN, ANY, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   SETIN, OK, NULL, NULL,

/* setout */
VERB_SETOUT, ANY, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   SETOUT, OK, NULL, NULL,

/* setmin */
VERB_SETMIN, ANY, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   SETMIN, OK, NULL, NULL,

/* setmout */
VERB_SETMOUT, ANY, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   SETMOUT, OK, NULL, NULL,

/* dig */
VERB_DIG, ANY, ANY,
   HERE,236, STATE,236, NULL,1, PAR,236, PAR,0, PAR,0,
   SETSTATE, 256, DONE, NULL,

/* dig */
VERB_DIG, ANY, ANY,
   HERE,237, STATE,237, NULL,1, PAR,237, PAR,0, PAR,0,
   SETSTATE, 256, DONE, NULL,

/* dig */
VERB_DIG, ANY, ANY,
   DESTROYED,186, IN,-651, PAR,186, PAR,0, PAR,0, PAR,0,
   200, CREATE, OK, NULL,

/* dig */
VERB_DIG, ANY, ANY,
   NOT|IN,-172, NOT|IN,-192, PAR,0, PAR,0, PAR,0, PAR,0,
   201, OK, NULL, NULL,

/* dig */
VERB_DIG, ANY, OB,
   OBIT,FL_OB2, NULL,15, STATE,176, NULL,1, PAR,176, PAR,0,
   203, DEC, OK, NULL,

/* dig */
VERB_DIG, OB, ANY,
   OBIT,FL_OB1, NULL,15, STATE,176, NULL,1, PAR,176, PAR,0,
   203, DEC, OK, NULL,

/* dig */
VERB_DIG, ANY, ANY,
   STATE,176, NULL,0, PAR,0, PAR,0, PAR,0, PAR,0,
   202, DONE, NULL, NULL,

/* dig */
VERB_DIG, ANY, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   254, DONE, NULL, NULL,

/* open tree */
VERB_OPEN, OBJ_TREE, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   238, DONE, NULL, NULL,

/* open tree 1 */
VERB_OPEN, OBJ_TREE_1, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   238, DONE, NULL, NULL,

/* light tree 1 */
VERB_LIGHT, OBJ_TREE_1, ANY,
   HASANY,13, PAR,239, PAR,-524, PAR,100, PAR,0, PAR,0,
   239, DESTROY, GOTO, GAIN,

/* tickle tree 1*/
VERB_TICKLE, OBJ_TREE_1, ANY,
   PAR,239, PAR,-524, PAR,100, PAR,0, PAR,0, PAR,0,
   246, DESTROY, GOTO, GAIN,

/* light tree 1 */
VERB_LIGHT, OBJ_TREE_1, ANY,
   HASANY,13, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   DONE, NULL, NULL, NULL,

/* look */
VERB_LOOK, ANY, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   LOOK, DONE, NULL, NULL,

/* inv */
VERB_INV, ANY, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   INVEN, DONE, NULL, NULL,

/* look */
VERB_LOOK, ANY, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   DISPROOM, DONE, NULL, NULL,

/* inv */
VERB_INV, ANY, ANY, 
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   WHO, DONE, NULL, NULL,

/* summon */
VERB_SUMMON, ANY, ANY,
   IN,-2300, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   234, DONE, NULL, NULL,

/* shout */
VERB_SHOUT, ANY, ANY,
   IFDUMB,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   207, DONE, NULL, NULL,

/* say */
VERB_SAY, ANY, ANY,
   IFDUMB,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   207, DONE, NULL, NULL,

/* tell */
VERB_TELL, ANY, ANY,
   IFDUMB,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   207, DONE, NULL, NULL,

/* shout */
VERB_SHOUT, ANY, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   SHOUT, OK, NULL, NULL,

/* say */
VERB_SAY, ANY, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   SAY, OK, NULL, NULL,

/* tell */
VERB_TELL, ANY, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   TELL, OK, NULL, NULL,

/* score */
VERB_SCORE, ANY, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   SCORE, DONE, NULL, NULL,

/* give */
VERB_GIVE, OBJ_RUNESWORD, ANY,
   NOT|WIZ,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   205, DONE, NULL, NULL,

/* give */
VERB_GIVE, ANY, OBJ_RUNESWORD,
   NOT|WIZ,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   205, DONE, NULL, NULL,

/* give */
VERB_GIVE, ANY, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   GIVE, OK, NULL, NULL,

/* exorcise */
VERB_EXORCISE, ANY, ANY,
   NOT|WIZ,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   208, DONE, NULL, NULL,

/* exorcise */
VERB_EXORCISE, PL, ANY,
   PFLAG, FL_PL1, NULL, 1, PAR,0, PAR,0, PAR,0, PAR,0,
   206, DONE, NULL, NULL,

/* exorcise */
VERB_EXORCISE, ANY, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   EXORCISE, DONE, NULL, NULL,

/* give */
VERB_GIVE, ANY, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   GIVE, OK, NULL, NULL,

/* give */
VERB_GIVE, ANY, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   GIVE, OK, NULL, NULL,

/* put */
VERB_PUT, OBJ_UMBRELLA, ANY, STATE, 1, NULL, 1, PAR,0, PAR,0, PAR,0, PAR,0,
	232, DONE, NULL, NULL,

/* open */
VERB_OPEN, OBJ_FLOORBOARDS, ANY,
   STATE,224, NULL,1, PAR,224, PAR,0, PAR,0, PAR,0,
   229, SETSTATE, OK, NULL,

/* open */
VERB_OPEN, OBJ_FLOORBOARDS_1, ANY,
   STATE,225, NULL,1, PAR,225, PAR,0, PAR,0, PAR,0,
   229, SETSTATE, OK, NULL,

/* open */
VERB_OPEN, OBJ_DOOR_1, ANY,
   STATE,21, NULL,0, PAR,0, PAR,0, PAR,0, PAR,0,
   210, DONE, NULL, NULL,

/* open */
VERB_OPEN, OBJ_DOOR_1, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   209, DONE, NULL, NULL,

/* open */
VERB_OPEN, OBJ_UMBRELLA, ANY,
   STATE,1, NULL,1, PAR,0, PAR,0, PAR,0, PAR,0,
   210, DONE, NULL, NULL,

/* open */
VERB_OPEN, OBJ_UMBRELLA, ANY,
   PAR,1, PAR,1, PAR,0, PAR,0, PAR,0, PAR,0,
   SETSTATE, 211, OK, NULL,

/* open */
VERB_OPEN, OBJ_DOOR, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   212, DONE, NULL, NULL,

/* open (can't open) */
VERB_OPEN, OB, ANY,
   NOT|OBIT,FL_OB1, NULL,2, PAR,0, PAR,0, PAR,0, PAR,0,
   213, DONE, NULL, NULL,

/* open */
VERB_OPEN, OB, ANY,
   STATE,FL_OB1, NULL,0, PAR,0, PAR,0, PAR,0, PAR,0,
   214, DONE, NULL, NULL,

/* open x with key */
VERB_OPEN, OB, ANY,
   STATE,FL_OB1, NULL,2, HASANY,11, PAR,FL_OB1, PAR,0, PAR,0,
   DEC, NULL, NULL, NULL,

/* open (locked) */
VERB_OPEN, OB, ANY,
   STATE,FL_OB1, NULL,2, PAR,0, PAR,0, PAR,0, PAR,0,
   215, DONE, NULL, NULL,

/* open */
VERB_OPEN, OB, ANY,
   PAR,FL_OB1, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   DEC, OK, NULL, NULL,

/* close */
VERB_CLOSE, OBJ_UMBRELLA, ANY,
   STATE,1, NULL,0, PAR,0, PAR,0, PAR,0, PAR,0,
   216, DONE, NULL, NULL,

/* close */
VERB_CLOSE, OBJ_UMBRELLA, ANY,
   PAR,1, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   SETSTATE, OK, NULL, NULL,

/* close */
VERB_CLOSE, OB, ANY,
   NOT|OBIT,FL_OB1, NULL,2, PAR,0, PAR,0, PAR,0, PAR,0,
   217, DONE, NULL, NULL,

/* close */
VERB_CLOSE, OB, ANY,
   NOT|STATE,FL_OB1, NULL,0, PAR,0, PAR,0, PAR,0, PAR,0,
   218, DONE, NULL, NULL,

/* close */
VERB_CLOSE, OB, ANY,
   PAR,FL_OB1, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   INC, OK, NULL, NULL,

/* lock */
VERB_LOCK, OB, ANY,
   NOT|HASANY,11, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   222, DONE, NULL, NULL,

/* lock */
VERB_LOCK, OB, ANY,
   NOT|OBIT,FL_OB1, NULL,3, PAR,0, PAR,0, PAR,0, PAR,0,
   223, DONE, NULL, NULL,

/* lock */
VERB_LOCK, OB, ANY,
   STATE,FL_OB1, NULL,2, PAR,0, PAR,0, PAR,0, PAR,0,
   224, DONE, NULL, NULL,

/* lock */
VERB_LOCK, OB, ANY,
   PAR,FL_OB1, PAR,2, PAR,0, PAR,0, PAR,0, PAR,0,
   SETSTATE, OK, NULL, NULL,

/* unlock */
VERB_UNLOCK, OB, ANY,
   NOT|HASANY,11, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   222, DONE, NULL, NULL,

/* unlock */
VERB_UNLOCK, OB, ANY,
   NOT|OBIT,FL_OB1, NULL,3, PAR,0, PAR,0, PAR,0, PAR,0,
   226, DONE, NULL, NULL,

/* unlock */
VERB_UNLOCK, OB, ANY,
   NOT|STATE,FL_OB1, PAR,2, PAR,0, PAR,0, PAR,0, PAR,0,
   225, DONE, NULL, NULL,

/* unlock */
VERB_UNLOCK, OB, ANY,
   PAR,FL_OB1, PAR,1, PAR,0, PAR,0, PAR,0, PAR,0,
   SETSTATE, OK, NULL, NULL,

/* shoot (dragon code; icy dagger) */
VERB_SHOOT, P(23), OBJ_DAGGER_1,
   PAR,23, PAR,1000, PAR,300, PHERE,23, PAR,0, PAR,0,
   221, WOUNDMON, GAIN, DONE,

/* shoot (dragon code) */
VERB_SHOOT, P(23), NONE,
   WPN,184, PAR,23, PAR,1000, PAR,300, PHERE,23, PAR,0,
   221, WOUNDMON, GAIN, DONE,

/* read (bone) */
VERB_READ, OBJ_BONE, ANY,
   IN, -212, PAR,-420, PAR,0, PAR,0, PAR,0, PAR,0,
   GOTO, 220, DONE, NULL,

/* read (bone) */
VERB_READ, OBJ_BONE, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   219, DONE, NULL, NULL,

/* shoot (hit the bell; bong!) */
VERB_SHOOT, OBJ_BELL, ANY,
   PAR,28, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   BROAD, OK, NULL, NULL,

/* ring (the bell) */
VERB_RING, OBJ_BELL, ANY,
   PAR,28, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   BROAD, OK, NULL, NULL,

/* shoot (hit pebble) */
VERB_SHOOT, OBJ_PEBBLE, ANY,
   PAR,218, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   231, DESTROY, DONE, NULL,

/* take */
VERB_TAKE, OBJ_ORNAMENTS, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   230, DONE, NULL, NULL,

/* begone */
VERB_BEGONE, PL, ANY,
   NOT|OP,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   204, DONE, NULL, NULL,

/* begone */
VERB_BEGONE, PL, ANY,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   KILLPL, OK, NULL, NULL,

/* null entry */
-1, 0, 0,
  PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
  0, 0, 0, 0,
};

/*
** Interrupts (called every two seconds via alarm).
**/

LINE inter[] = {

0, ANY, ANY,
   IN,-2300, CHANCE,20, NOT|WIZ,0, PAR,239, PAR,37, PAR,36,
   DEC, BROAD, QUIT, NULL,

0, ANY, ANY,
   HERE,242, AVL,45, NOT|WIZ,0, PAR,242, PAR,100, PAR,0,
   DESTROY, GAIN, 263, NULL,

-1, 0, 0,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   0, 0, 0, 0, 0
};

/*
** Status (called after each action is done).0
*/

LINE status[] = {

0, ANY, ANY,
   HERE, 239, STATE, 239, NULL, 0, CHANCE, 10, PAR,-2300, PAR,0,
   235, GOTO, NULL, NULL,

-1, 0, 0,
   PAR,0, PAR,0, PAR,0, PAR,0, PAR,0, PAR,0,
   0, 0, 0, 0, 0
};
