#include "kernel.h"
#include "objects.h"

#ifdef	RCSID
static char RCS[] =
	"$Header: extra.c,v 1.2 89/07/03 08:17:45 rsalz Exp $";
#endif	/* RCSID */


static int	 jumtb[] = {
    -643, -633, -1050, -662, -1082, -1053, 0, 0
};


helpcom()
{
    int a;
    char b[128];

    if (item1[0]) {
	if ((a = pl1) == -1) {
	    bprintf("Help who ?\n");
	    return;
	}
	if (ploc(a) != ploc(mynum)) {
	    bprintf("They are not here\n");
	    return;
	}
	if (a == mynum) {
	    bprintf("You can't help yourself.\n");
	    return;
	}
	if (phelping(mynum) != -1) {
	    sprintf(b, "\001p%s\001 has stopped helping you\n", pname(mynum));
	    sendsys(pname(a), pname(a), -10011, ploc(mynum), b);
	    bprintf("Stopped helping \001p%s\001.\n", pname(phelping(mynum)));
	}
	setphelping(mynum, a);
	sprintf(b, "\001p%s\001 has offered to help you\n", pname(mynum));
	sendsys(pname(a), pname(a), -10011, ploc(mynum), b);
	bprintf("OK...\n");
	return;
    }
    closeworld();
    bprintf("\001f%s\001", HELP1);
    if (plev(mynum) > 9) {
	pbfr();
	sig_alon();
	key_input("Hit <Return> For More....      ", 6);
	sig_aloff();
	bprintf("\001f%s\001", HELP2);
    }
    bprintf("\n");
    if (plev(mynum) > 9999) {
	pbfr();
	sig_alon();
	key_input("Hit <Return> For More....      ", 6);
	sig_aloff();
	bprintf("\001f%s\001", HELP3);

    }
    bprintf("\n");
}

levcom()
{
    closeworld();
    bprintf("\001f%s\001", LEVELS);
}

valuecom()
{
    int b;

    if ((b = ob1) == -1) {
	bprintf("There isn't one of those here.\n");
	return;
    }
    bprintf("%s : %d points\n", oname(b), (tscale() * (obaseval(b))) / 9);
}

stacom()
{
    int a;

    if (!item1[0]) {
	bprintf("STATS what ?\n");
	return;
    }
    if (plev(mynum) < 10) {
	bprintf("Sorry, this is a wizard command buster...\n");
	return;
    }
    if ((a = fobn(item1)) == -1) {
	statplyr();
	return;
    }
    bprintf("\nItem        :%s", oname(a));
    if (ocarrf(a) == 3)
	bprintf("\nContained in:%s", oname(oloc(a)));
    else {
	if (ocarrf(a) != 0)
	    bprintf("\nHeld By     :%s", pname(oloc(a)));
	else {
	    bprintf("\nPosition    :");
	    showname(oloc(a));
	}
    }
    bprintf("\nState       :%d", state(a));
    bprintf("\nCarr_Flag   :%d", ocarrf(a));
    bprintf("\nSpare       :%d", ospare(a));
    bprintf("\nMax State   :%d", omaxstate(a));
    bprintf("\nBase Value  :%d", obaseval(a));
    bprintf("\n");
}

examcom()
{
    int a;
    FILE *x;
    char r[88];

    if (!item1[0]) {
	bprintf("Examine what ?\n");
	return;
    }
    if ((a = ob1) == -1) {
	bprintf("You see nothing special at all\n");
	return;
    }
    switch (a) {
    case OBJ_TUBE:
	if (obyte(OBJ_TUBE, 0) == 0) {
	    osetbyte(OBJ_TUBE, 0, 1);
	    bprintf("You take a scroll from the tube.\n");
	    oclrbit(OBJ_SCROLL_1, 0);
	    setoloc(OBJ_SCROLL_1, mynum, 1);
	    return;
	}
	break;
    case OBJ_SCROLL_1:
	setploc(mynum, -114);
	bprintf("As you read the scroll you are teleported!\n");
	destroy(OBJ_SCROLL_1);
	trapch(ploc(mynum));
	return;
    case OBJ_ROBE:
	if (obyte(OBJ_ROBE, 0) == 0) {
	    bprintf("You take a key from one pocket\n");
	    osetbyte(OBJ_ROBE, 0, 1);
	    oclrbit(OBJ_KEY_2, 0);
	    setoloc(OBJ_KEY_2, mynum, 1);
	    return;
	}
	break;
    case OBJ_WAND:
	if (obyte(OBJ_WAND, 1) != 0) {
	    bprintf("It seems to be charged\n");
	    return;
	}
	break;
    case OBJ_BALL:
	setobjstate(OBJ_BALL, randperc() % 3 + 1);
	switch (state(OBJ_BALL)) {
	case 1:
	    bprintf("It glows red");
	    break;
	case 2:
	    bprintf("It glows blue");
	    break;
	case 3:
	    bprintf("It glows green");
	    break;
	}
	bprintf("\n");
	return;
    case OBJ_SCROLL:
	if (state(OBJ_BALL) != 0) {
	    if (iscarrby(3 + state(OBJ_BALL), mynum) &&
                otstbit(3 + state(OBJ_BALL), 13)) {
		bprintf("Everything shimmers and then solidifies into a different view!\n");
		destroy(OBJ_SCROLL);
		teletrap(-1074);
		return;
	    }
	}
	break;
    case OBJ_BED:
	if (!obyte(OBJ_BED, 0)) {
	    bprintf("Aha. under the bed you find a loaf and a rabbit pie\n");
	    oclrbit(OBJ_LOAF, 0);
	    oclrbit(OBJ_PIE, 0);
	    osetbyte(OBJ_LOAF, 0, 1);
	    return;
	}
	break;
    case OBJ_BEDDING:
	if (!obyte(OBJ_AMULET, 0)) {
	    oclrbit(OBJ_AMULET, 0);
	    bprintf("You pull an amulet from the bedding\n");
	    osetbyte(OBJ_AMULET, 0, 1);
	    return;
	}
	break;
    }

    if (a < 10)
	sprintf(r, "%s00%d", EXAMINES, a);
    else if (a < 100)
	sprintf(r, "%s0%d", EXAMINES, a);
    else
	sprintf(r, "%s%d", EXAMINES, a);
    if ((x = fopen(r, "r")) == NULL)
	bprintf("You see nothing special.\n");
    else {
	while (fgets(r, sizeof r, x))
	    bprintf("%s", r);
	fclose(x);
    }
}

statplyr()
{
    int b;

    if ((b = fpbn(item1)) == -1)
	bprintf("Whats that ?\n");
    else {
	bprintf("Name      : %s\n", pname(b));
	bprintf("Level     : %d\n", plev(b));
	bprintf("Vis Level : %d\n", pvis(b));
	bprintf("Strength  : %d\n", pstr(b));
	bprintf("Sex       : %s\n", (psex(b) == 0) ? "MALE" : "FEMALE");
	bprintf("Score     : %d\n", pscore(b));
	bprintf("Location  : ");
	showname(ploc(b));
    }
}

wizlist()
{
    if (plev(mynum) < 10)
	bprintf("Huh ?\n");
    else {
	closeworld();
	bprintf("\001f%s\001", WIZLIST);
    }
}

incom()
{
    char st[80], rn[80], rv[80];
    int x;
    int y;

    if (plev(mynum) < 10) {
	bprintf("Huh\n");
	return;
    }
    if (brkword() == -1) {
	bprintf("In where ?\n");
	return;
    }
    strcpy(rn, wordbuf);
    if (brkword() == -1) {
	bprintf("In where ?\n");
	return;
    }
    strcpy(rv, wordbuf);
    if ((x = roomnum(rn, rv)) == 0) {
	bprintf("Where is that ?\n");
	return;
    }
    getreinput(st);
    y = ploc(mynum);
    setploc(mynum, x);
    if (!exists(x)) {
	setploc(mynum, y);
	bprintf("No such room\n");
	return;
    }
    gamecom(st);
    setploc(mynum, y);
}

jumpcom()
{
    int a, b;
    char ms[128];

    for (a = 0, b = 0; jumtb[a]; a += 2)
	if (jumtb[a] == ploc(mynum)) {
	    b = jumtb[a + 1];
	    break;
	}
    if (b == 0) {
	bprintf("Wheeeeee....\n");
	return;
    }
    if (plev(mynum) < 10 && (!iscarrby(OBJ_UMBRELLA, mynum) ||
        state(OBJ_UMBRELLA) == 0)) {
   	   setploc(mynum, b);
	   bprintf("Wheeeeeeeeeeeeeeeee  <<<<SPLAT>>>>\n");
	   bprintf("You seem to be splattered all over the place\n");
	   loseme();
	   crapup("I suppose you could be scraped up - with a spatula");
    }
    sprintf(ms, "\001s%s\001%s has just left\n\001",
	pname(mynum), pname(mynum));
    sendsys(pname(mynum), pname(mynum), -10000, ploc(mynum), ms);
    setploc(mynum, b);
    sprintf(ms, "\001s%s\001%s has just dropped in\n\001",
	pname(mynum), pname(mynum));
    sendsys(pname(mynum), pname(mynum), -10000, ploc(mynum), ms);
    trapch(b);
}


wherecom()
{
    int cha, rnd;

    if (pstr(mynum) < 10) {
	bprintf("You are too weak\n");
	return;
    }
    if (plev(mynum) < 10)
	setpstr(mynum, pstr(mynum) - 2);
    rnd = randperc();
    cha = 10 * plev(mynum);
    if (iscarrby(OBJ_POWERSTONE, mynum) || iscarrby(OBJ_POWERSTONE_1, mynum)
       || iscarrby(OBJ_POWERSTONE_2, mynum))
	cha = 100;
    closeworld();
    if (rnd > cha) {
	bprintf("Your spell fails...\n");
	return;
    }
    if (!item1[0]) {
	bprintf("What is that ?\n");
	return;
    }
    if (EQ(item1, "<null>")) {
	bprintf("NULL, we don't have NULLs in this game!\n");
	return;
    }

    for (cha = 0, rnd = 0; cha < numobs; cha++) {
	if (EQ(oname(cha), item1) || EQ(oaltname(cha), item1)) {
	    rnd = 1;
	    if (plev(mynum) > 9999)
		bprintf("[%3d]", cha);
	    bprintf("%16s - ", oname(cha));
	    if ((plev(mynum) < 10) && (ospare(cha) == -1))
		bprintf("Nowhere\n");
	    else
		desrm(oloc(cha), ocarrf(cha));
	}
    }

    if ((cha = pl1) != -1) {
	rnd++;
	bprintf("%s - ", pname(cha));
	desrm(ploc(cha), 0);
    }
    if (!rnd)
	bprintf("I dont know what that is\n");
}

desrm(loc, cf)
    int loc, cf;
{
    int wizinvis, awizinvis;

    if (plev(mynum) < 10 && cf == 0 && loc > -5) {
	bprintf("Somewhere.....\n");
	return;
    }
    if (cf == 3) {
	bprintf("In the %s\n", oname(loc));
	return;
    }

    if (cf > 0) {
	wizinvis = (plev(loc) > 10 && pvis(loc));
	awizinvis = (plev(loc) > 9999 && pvis(loc));
	if ((wizinvis && plev(mynum) <= 10)
	 || (awizinvis && plev(mynum) < 9999))
	    bprintf("Somewhere.....\n");
	else
	    bprintf("Carried by \001c%s\001\n", pname(loc));
	return;
    }

    if (!exists(loc)) {
	if (plev(mynum) < 10000)
	    bprintf("Out in the void\n");
	else
	    bprintf("NOT IN UNIVERSE[%d]\n", loc);
	return;
    }
    bprintf("%-36s", sdesc(loc));
    if (plev(mynum) < 10)
	bprintf("\n");
    else if (!cf || (plev(mynum) > 9 && !awizinvis) || plev(mynum) > 9999) {
	bprintf(" | ");
	showname(loc);
    }
    else
	bprintf("\n");
}


edit_world()
{
    int b, c, d;

    if (!ptstflg(mynum, 5)) {
	bprintf("Must be Game Administrator\n");
	return;
    }
    if (brkword() == -1) {
	bprintf("Must Specify Player or Object\n");
	return;
    }
    if (EQ(wordbuf, "player")) {
	if ((b = getnarg(0, 47)) == -1)
	    return;
	if ((c = getnarg(0, 15)) == -1)
	    return;
	if ((d = getnarg(0, 0)) == -1)
	    return;
	ublock[16 * b + c] = d;
    }
    else if (EQ(wordbuf, "object")) {
	if ((b = getnarg(0, numobs - 1)) == -1)
	    return;
	if ((c = getnarg(0, 3)) == -1)
	    return;
	if ((d = getnarg(0, 0)) == -1)
	    return;
	objinfo[4 * b + c] = d;
    }
    else {
	bprintf("Must specify Player or Object\n");
	return;
    }
    bprintf("Tis done\n");
}


int 
getnarg(bt, to)
    int bt, to;
{
    int x;

    if (brkword() == -1) {
	bprintf("Missing numeric argument\n");
	return -1;
    }
    x = atoi(wordbuf);
    if ((bt != to && x < bt) || (to && x > to)) {
	bprintf("Invalid range\n");
	return -1;
    }
    return x;
}
